## openio-sds 3.2.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project (OIOSDS C)

include(CheckIncludeFile)
include(CheckLibraryExists)
include(CheckTypeSize)
#include(FindFLEX)
#include(FindBISON)
include(FindCURL)
include(FindPythonInterp)
include(FindZLIB)
find_package(PkgConfig)

if (NOT DEFINED OIOSDS_RELEASE)
	set(OIOSDS_RELEASE master)
endif ()
if (NOT DEFINED OIOSDS_PROJECT_VERSION_SHORT)
	set(OIOSDS_PROJECT_VERSION_SHORT "3.0")
endif ()

set(OIOSDS_PROJECT_VERSION "${OIOSDS_RELEASE}/${OIOSDS_PROJECT_VERSION_SHORT}")

if (NOT ABI_VERSION)
	set(ABI_VERSION 0)
endif()

set(CMAKE_C_FLAGS "-g -fPIC -pipe -Wall -Wextra -std=gnu99")

# necessary to benefit from zero'ed static allocation of structures
# as proposed by C99. (we only allocate the first field and let the compiler
# init the others to zero.
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-missing-field-initializers")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=missing-braces")

if (CMAKE_COMPILER_IS_GNUCC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wunused")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-variadic-macros")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wsequence-point")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wredundant-decls")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow")

	# gcc >= 4.2
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcomment")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmain")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wparentheses")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wfloat-equal")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wunsafe-loop-optimizations")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wunused-but-set-parameter")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wunused-but-set-variable")

	# gcc >= 4.6
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-prototypes")
	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wconversion")
	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wswitch-enum")
endif()

set(CMAKE_C_FLAGS_DEBUG          "-O0 -fno-inline")
set(CMAKE_C_FLAGS_RELEASE        "-O2")
set(CMAKE_C_FLAGS_RELWITHDEBINFO "-O2 -fno-inline")
set(CMAKE_C_FLAGS_MINSIZEREL     "-Os -s")

add_definitions(-D_REENTRANT)
add_definitions(-D_LARGE_FILES)
add_definitions(-D_LARGEFILE_SOURCE)
add_definitions(-D_LARGEFILE64_SOURCE)
add_definitions(-D_FILE_OFFSET_BITS=64)
add_definitions(-DHAVE_SOCKLEN_T)
add_definitions(-DOIOSDS_PROJECT_VERSION="${OIOSDS_PROJECT_VERSION}")
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
	MESSAGE("DEBUG symbols enabled")
	add_definitions(-DG_ERRORCHECK_MUTEXES)
	add_definitions(-DHAVE_EXTRA_ASSERT=1)
	add_definitions(-DHAVE_EXTRA_DEBUG=1)
endif()

option(ENBUG "Introduces intentional bugs" OFF)
if (ENBUG)
	MESSAGE(WARNING "ENBUGED MODE : NOT FOR PRODUCTION USE")
	add_definitions(-DHAVE_ENBUG=1)
endif()

if (DEFINED STACK_PROTECTOR)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
endif()
if (SOCKET_OPTIMIZED)
	add_definitions(-D_GNU_SOURCE)
	add_definitions(-DHAVE_SOCKET3)
	add_definitions(-DHAVE_ACCEPT4)
endif()
if (FORBID_SLICE)
	add_definitions(-DHAVE_NO_SLICE)
endif()
if (ALLOW_BACKTRACE)
	add_definitions(-DHAVE_BACKTRACE)
endif()
if (SOCKET_LINGER_ONOFF)
	add_definitions(-DSOCK_DEFAULT_LINGER_ONOFF=${SOCKET_LINGER_ONOFF})
endif ()
if (SOCKET_LINGER_DELAY)
	add_definitions(-DSOCK_DEFAULT_LINGER_DELAY=${SOCKET_LINGER_DELAY})
endif ()
if (FORBID_DEPRECATED)
	add_definitions(-DG_DISABLE_DEPRECATED=1)
endif ()

MESSAGE("FORBID_SLICE ${FORBID_SLICE}")
MESSAGE("STACK_PROTECTOR ${STACK_PROTECTOR}")
MESSAGE("FORBID_DEPRECATED ${FORBID_DEPRECATED}")
MESSAGE("SOCKET_OPTIMIZED ${SOCKET_OPTIMIZED}")
MESSAGE("SOCKET_LINGER_ONOFF ${SOCKET_LINGER_ONOFF}")
MESSAGE("SOCKET_LINGER_DELAY ${SOCKET_LINGER_DELAY}")

###-------------------------------------------------------------------------###

macro (dir2macro2 N D)
	if (${N})
		add_definitions(-D${N}=${${N}})
		MESSAGE("CFLAGS: ${N} = ${${N}}")
	else ()
		add_definitions(-D${N}=${D})
		MESSAGE("CFLAGS: ${N} = ${D} (default)")
	endif ()
endmacro ()

macro (dir2macro N)
	if (${N})
		add_definitions(-D${N}=${${N}})
		MESSAGE("CFLAGS: ${N} = ${${N}}")
	else ()
		MESSAGE("CFLAGS: ${N} left to default")
	endif ()
endmacro ()

macro(test_CLI var msg)
	if (${var})
		MESSAGE(STATUS "FOUND CLI ${msg} : ${${var}}")
	else ()
		MESSAGE(FATAL_ERROR "NOT FOUND CLI ${msg}")
	endif ()
endmacro()

function (print_found arg)
	MESSAGE (STATUS "### ${arg} F=${${arg}_FOUND} V=${${arg}_VERSION} I=${${arg}_INCLUDE_DIRS} LD=${${arg}_LIBRARY_DIRS} L=${${arg}_LIBRARIES} H=${${arg}_HEADER}")
endfunction()

function (check_found)
	foreach (arg ${ARGN})
		print_found (${arg})
	endforeach()
	foreach (arg ${ARGN})
		if (NOT ${arg}_FOUND)
			MESSAGE(FATAL_ERROR " ${arg} not found")
		endif ()
	endforeach ()
endfunction()

macro (option_or_system _PREFIX _LIB)

	# Set configured defaults
	if (NOT DEFINED ${_PREFIX}_INCLUDE_DIRS)
		set (${_PREFIX}_INCLUDE_DIRS "${DEFAULT_INCLUDE_DIRS}" )
	endif ()
	if (NOT DEFINED ${_PREFIX}_LIBRARY_DIRS)
		set (${_PREFIX}_LIBRARY_DIRS "${DEFAULT_LIBRARY_DIRS}" )
	endif ()

	# Override with CLI options
	if (DEFINED ${_PREFIX}_INCDIR)
		set (${_PREFIX}_INCLUDE_DIRS ${${_PREFIX}_INCDIR} )
	endif ()
	if (DEFINED ${_PREFIX}_LIBDIR)
		set (${_PREFIX}_LIBRARY_DIRS ${${_PREFIX}_LIBDIR} )
	endif ()

	# Check expected elements are present
	find_library (${_PREFIX}_LIBRARIES ${_LIB} ${${_PREFIX}_LIBRARY_DIRS})
	set (_FOUND true)
	set (_HEADERS "")
	foreach (arg ${ARGN})
		if (_FOUND)
			find_file (_HEADER ${arg} ${${_PREFIX}_INCLUDE_DIRS})
			if (NOT _HEADER OR _HEADER MATCHES ".*NOTFOUND$")
				set (_FOUND false)
			else ()
				set (_HEADERS "${_HEADERS}:${_HEADER}")
			endif ()
			unset(_HEADER CACHE)
		endif ()
	endforeach ()

	if (NOT ${_PREFIX}_LIBRARIES OR ${_PREFIX}_LIBRARIES MATCHES ".*NOTFOUND$")
		set (${_PREFIX}_FOUND true )
	endif ()
	set (${_PREFIX}_FOUND ${_FOUND} )
	set (${_PREFIX}_HEADER "${_HEADERS}")
	unset(_FOUND CACHE)
	unset(_HEADERS CACHE)
endmacro ()

macro(bin_prefix T N)
	if (NOT DEFINED EXE_PREFIX)
		set(EXE_PREFIX "oio")
	endif ()
	set_target_properties(${T} PROPERTIES OUTPUT_NAME ${EXE_PREFIX}${N})
endmacro ()

###-------------------------------------------------------------------------###

dir2macro("GCLUSTER_RUN_DIR")
dir2macro("GCLUSTER_ETC_DIR")

dir2macro("GCLUSTER_CONFIG_FILE_PATH")
dir2macro("GCLUSTER_CONFIG_DIR_PATH")
dir2macro("GCLUSTER_CONFIG_LOCAL_PATH")
dir2macro("GCLUSTER_AGENT_SOCK_PATH")

dir2macro("GS_CONFIG_NSINFO_REFRESH")

dir2macro("OIO_EVT_BEANSTALKD_DEFAULT_PRIO")
dir2macro("OIO_EVT_BEANSTALKD_DEFAULT_DELAY")
dir2macro("OIO_EVT_BEANSTALKD_DEFAULT_TTR")
dir2macro("OIO_EVT_BEANSTALKD_DEFAULT_TUBE")

dir2macro("OIO_ETC_DIR")
dir2macro("OIO_CONFIG_FILE_PATH")
dir2macro("OIO_CONFIG_DIR_PATH")
dir2macro("OIO_CONFIG_LOCAL_PATH")
dir2macro("OIO_DEFAULT_STGPOL")
dir2macro("OIO_DEFAULT_CHUNKMETHOD")
dir2macro("OIO_DEFAULT_MIMETYPE")

dir2macro("PROXYD_PREFIX")
dir2macro("PROXYD_HEADER_PREFIX")
dir2macro("PROXYD_HEADER_MODE")
dir2macro("PROXYD_HEADER_REQID")
dir2macro("PROXYD_HEADER_NOEMPTY")
dir2macro("PROXYD_PATH_MAXLEN")
dir2macro("PROXYD_DEFAULT_TTL_CSM0")
dir2macro("PROXYD_DEFAULT_MAX_CSM0")
dir2macro("PROXYD_DEFAULT_TTL_SERVICES")
dir2macro("PROXYD_DEFAULT_MAX_SERVICES")
dir2macro("PROXYD_PERIOD_RELOAD_NSINFO")
dir2macro("PROXYD_PERIOD_RELOAD_CSURL")
dir2macro("PROXYD_PERIOD_RELOAD_SRVTYPES")
dir2macro("PROXYD_PERIOD_RELOAD_M0INFO")
dir2macro("PROXYD_TTL_DEAD_LOCAL_SERVICES")
dir2macro("PROXYD_TTL_DOWN_SERVICES")
dir2macro("PROXYD_TTL_KNOWN_SERVICES")
dir2macro("PROXYD_TTL_MASTER_SERVICES")
dir2macro("PROXYD_DEFAULT_TIMEOUT_CONSCIENCE")
dir2macro("PROXYD_DEFAULT_PERIOD_DOWNSTREAM")
dir2macro("PROXYD_DEFAULT_PERIOD_UPSTREAM")

dir2macro("OIO_EVTQ_MAXPENDING")

dir2macro("SQLX_DIR_SCHEMAS")
dir2macro("SQLX_ADMIN_PREFIX_SYS")
dir2macro("SQLX_ADMIN_PREFIX_USER")
dir2macro("SQLX_ADMIN_INITFLAG")
dir2macro("SQLX_ADMIN_STATUS")
dir2macro("SQLX_ADMIN_REFERENCE")
dir2macro("SQLX_ADMIN_BASENAME")
dir2macro("SQLX_ADMIN_BASETYPE")
dir2macro("SQLX_ADMIN_NAMESPACE")

dir2macro("M2V2_ADMIN_PREFIX_SYS")
dir2macro("M2V2_ADMIN_PREFIX_USER")
dir2macro("M2V2_ADMIN_VERSION")
dir2macro("M2V2_ADMIN_QUOTA")
dir2macro("M2V2_ADMIN_SIZE")
dir2macro("M2V2_ADMIN_CTIME")
dir2macro("M2V2_ADMIN_VERSIONING_POLICY")
dir2macro("M2V2_ADMIN_STORAGE_POLICY")
dir2macro("M2V2_ADMIN_KEEP_DELETED_DELAY")

dir2macro("META2_INIT_FLAG")

dir2macro("COMMON_CNX_TIMEOUT")
dir2macro("COMMON_CLIENT_TIMEOUT")
dir2macro("M2V2_CLIENT_TIMEOUT")
dir2macro("M2V2_CLIENT_TIMEOUT_HUGE")
dir2macro("M1V2_CLIENT_TIMEOUT")
dir2macro("M0V2_CLIENT_TIMEOUT")
dir2macro("CS_CLIENT_TIMEOUT")

dir2macro("SERVER_DEFAULT_EPOLL_MAXEV")
dir2macro("SERVER_DEFAULT_ACCEPT_MAX")
dir2macro("SERVER_DEFAULT_THP_MAXUNUSED")
dir2macro("SERVER_DEFAULT_THP_MAXWORKERS")
dir2macro("SERVER_DEFAULT_THP_IDLE")
dir2macro("SERVER_DEFAULT_CNX_IDLE")
dir2macro("SERVER_DEFAULT_CNX_LIFETIME")
dir2macro("SERVER_DEFAULT_CNX_INACTIVE")
dir2macro("DAEMON_DEFAULT_TIMEOUT_READ")
dir2macro("DAEMON_DEFAULT_TIMEOUT_ACCEPT")

dir2macro("OIO_USE_OLD_FMEMOPEN")

dir2macro("SQLX_GRACE_DELAY_COOL")
dir2macro("SQLX_GRACE_DELAY_HOT")
dir2macro("SQLX_DELAY_MAXWAIT")
dir2macro("SQLX_DELAY_MAXIDLE")
dir2macro("SQLX_DELAY_ELECTION_REPLAY")
dir2macro("SQLX_DELAY_RESTART_FAILED")
dir2macro("SQLX_DELAY_PING_FAILED")
dir2macro("SQLX_DELAY_PING_FINAL")
dir2macro("SQLX_DELAY_PING_PENDING")
dir2macro("SQLX_DELAY_EXPIRE_FAILED")
dir2macro("SQLX_DELAY_EXPIRE_FINAL")
dir2macro("SQLX_DELAY_EXPIRE_PENDING")

###-------------------------------------------------------------------------###

if (NOT DEFINED CMAKE_INSTALL_PREFIX)
	set (CMAKE_INSTALL_PREFIX "/usr/local")
endif ()
MESSAGE(STATUS "Installation prefix : ${CMAKE_INSTALL_PREFIX}")


if (LD_LIBEXECDIR)
	MESSAGE("LD_LIBEXECDIR explicitely set to ${LD_LIBEXECDIR}")
else ()
	set (LD_LIBEXECDIR "libexec")
	MESSAGE("LD_LIBEXECDIR set to ${LD_LIBEXECDIR} (default)")
endif ()

if (LD_LIBDIR)
	MESSAGE("LD_LIBDIR explicitely set to ${LD_LIBDIR}")
else()
	CHECK_TYPE_SIZE(long SIZEOF_LONG)
	MESSAGE(STATUS "sizeof(long) = ${SIZEOF_LONG}")
	if (SIZEOF_LONG EQUAL 8)
		set (LD_LIBDIR "lib64")
	else ()
		set (LD_LIBDIR "lib")
	endif ()
	MESSAGE("LD_LIBDIR set to ${LD_LIBDIR} (default)")
endif()

if (PKGCONFIG_DIRECTORY)
	MESSAGE("PKGCONFIG_DIRECTORY explicitely set to ${PKGCONFIG_DIRECTORY}")
else ()
	set(PKGCONFIG_DIRECTORY "${CMAKE_INSTALL_PREFIX}/${LD_LIBDIR}/pkgconfig")
	MESSAGE("PKGCONFIG_DIRECTORY set to ${PKGCONFIG_DIRECTORY} (default)")
endif ()

set (GRIDD_PLUGINS_DIRECTORY "${LD_LIBDIR}/grid")
if (DEFINED GRIDD_PLUGINS)
	set(GRIDD_PLUGINS_DIRECTORY "${GRIDD_PLUGINS}")
endif ()

###-------------------------------------------------------------------------###

if (NOT SDK_ONLY)
find_program(BISON_EXECUTABLE bison)
find_program(FLEX_EXECUTABLE flex)
test_CLI(FLEX_EXECUTABLE "flex")
test_CLI(BISON_EXECUTABLE "bison")
endif(NOT SDK_ONLY)

# Set defaults
set(DEFAULT_LIBRARY_DIRS "/usr/${LD_LIBDIR}")
set(DEFAULT_INCLUDE_DIRS "/usr/include")
set(LZO_INCLUDE_DIRS "${DEFAULT_INCLUDE_DIRS}/lzo")
set(APACHE2_LIBRARY_DIRS "${DEFAULT_LIBRARY_DIRS}/httpd")
set(APACHE2_INCLUDE_DIRS "${DEFAULT_INCLUDE_DIRS}/httpd")
set(ATTR_INCLUDE_DIRS "${DEFAULT_INCLUDE_DIRS}/attr")
set(ZK_INCLUDE_DIRS "${DEFAULT_INCLUDE_DIRS}/zookeeper")

# check system configuration
pkg_search_module(JSONC json json-c)
pkg_check_modules(GLIB2 REQUIRED glib-2.0 gthread-2.0 gmodule-2.0)
pkg_check_modules(CURL curl libcurl)

if (NOT SDK_ONLY)
pkg_check_modules(APR REQUIRED apr-1)
pkg_check_modules(SQLITE3 REQUIRED sqlite3)
pkg_check_modules(ZMQ libzmq>=4.0.0)
# Optional cache libraries
pkg_search_module(HIREDIS hiredis)
pkg_search_module(LIBMEMCACHED libmemcached)

endif (NOT SDK_ONLY)

# Load CLI-overriden configuration
option_or_system(CURL curl curl/curl.h)
option_or_system(JSONC json-c json.h)

if (NOT SDK_ONLY)
option_or_system(ASN1C asn1cskeletons)
option_or_system(APACHE2 modules/mod_webdav.so httpd.h)
option_or_system(ATTR attr attr/xattr.h)
option_or_system(LZO lzo2 lzo1.h lzo1x.h lzoutil.h)
option_or_system(ZK zookeeper_mt zookeeper.h)

=== core/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.core")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ..)

include_directories(AFTER
		${GLIB2_INCLUDE_DIRS}
		${CURL_INCLUDE_DIRS}
		${JSONC_INCLUDE_DIRS})

link_directories(
		${GLIB2_LIBRARY_DIRS}
		${CURL_LIBRARY_DIRS}
		${JSONC_LIBRARY_DIRS})

add_library(oiocore SHARED url.c cfg.c str.c ext.c log.c lb.c)
target_link_libraries(oiocore
		${JSONC_LIBRARIES} ${GLIB2_LIBRARIES})
set_target_properties(oiocore PROPERTIES
		PUBLIC_HEADER "oio_core.h"
		SOVERSION ${ABI_VERSION})

add_library(oiosds SHARED sds.c proxy.c headers.c http_put.c dir.c cs.c)
target_link_libraries(oiosds oiocore
		${GLIB2_LIBRARIES} ${CURL_LIBRARIES} ${JSONC_LIBRARIES})
set_target_properties(oiosds PROPERTIES
		PUBLIC_HEADER "oio_sds.h"
		SOVERSION ${ABI_VERSION})

add_executable(tool_sdk tool_sdk.c)
target_link_libraries(tool_sdk oiosds)

add_executable(tool_roundtrip tool_roundtrip.c)
target_link_libraries(tool_roundtrip oiosds)

add_executable(tool_config tool_config.c)
target_link_libraries(tool_config oiosds)

add_executable(tool_ns tool_ns.c)
target_link_libraries(tool_ns oiosds ${CURL_LIBRARIES})

install(FILES
		oiocfg.h
		oiodir.h
		oioext.h
		oiolog.h
		oiostr.h
		oiourl.h
		oiocs.h
		oiolb.h
		DESTINATION include/core)

install(TARGETS oiocore oiosds
		LIBRARY DESTINATION ${LD_LIBDIR}
		PUBLIC_HEADER DESTINATION include)

=== meta0v2/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.m0v2" -DTHREADED)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ..)

link_directories(
		${ZK_LIBRARY_DIRS}
		${SQLITE3_LIBRARY_DIRS})


add_library(meta0remote SHARED meta0_remote.c meta0_remote.h)
set_target_properties(meta0remote PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(meta0remote
		metautils
		${GLIB2_LIBRARIES})


add_library(meta0utils SHARED meta0_utils.c meta0_utils.h)
set_target_properties(meta0utils PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(meta0utils
		metautils gridcluster
		${GLIB2_LIBRARIES})


add_library(meta0v2 SHARED meta0_backend.h meta0_backend.c)
set_target_properties(meta0v2 PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(meta0v2
		meta0utils metautils gridcluster sqliterepo
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})


add_executable(meta0_client meta0_client.c)
bin_prefix(meta0_client -meta0-client)
target_link_libraries(meta0_client gridcluster
		meta0remote meta0utils metautils server)


add_executable(meta0_init meta0_init.c)
bin_prefix(meta0_init -meta0-init)
target_link_libraries(meta0_init gridcluster
		meta0remote meta0utils metautils server)


#add_executable(meta0_backend_test meta0_backend_test.c)
#target_link_libraries(meta0_backend_test
#		meta0v2 metautils server sqliterepo)


add_executable(meta0_server
		meta0_gridd_dispatcher.c meta0_server.c)
bin_prefix(meta0_server -meta0-server)
target_link_libraries(meta0_server
		meta0v2 meta0utils
        metautils gridcluster server sqliterepo
		sqlxsrv
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

install(TARGETS meta0utils meta0remote meta0v2 meta0_server meta0_client meta0_init
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

install(TARGETS meta0remote
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== proxy/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.proxy")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

add_definitions(-DHAVE_UGLY_RC_FUNCTIONS=1)

include_directories(BEFORE
		..
		${CMAKE_CURRENT_BINARY_DIR}/..)

include_directories(AFTER
		${GLIB2_INCLUDE_DIRS}
		${CURL_INCLUDE_DIRS}
		${JSONC_INCLUDE_DIRS})

link_directories(
		${GLIB2_LIBRARY_DIRS}
		${CURL_LIBRARY_DIRS}
		${JSONC_LIBRARY_DIRS})

add_executable(metacd_http
    metacd_http.c
    common.c
    admin_actions.c
    cache_actions.c
    cs_actions.c
    lb_actions.c
    dir_actions.c
    m2_actions.c
    sqlx_actions.c
    reply.c
    path_parser.c
    transport_http.c)

bin_prefix(metacd_http -proxy)

target_link_libraries(metacd_http
		metautils server hcresolve gridcluster
		meta2v2remote meta2v2utils
		meta1remote sqlitereporemote
		meta0remote meta0utils
		${GLIB2_LIBRARIES} ${JSONC_LIBRARIES} ${CURL_LIBRARIES})

install(TARGETS metacd_http 
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== sqliterepo/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.sqlite" -DTHREADED)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ..
		${CMAKE_CURRENT_BINARY_DIR}/../metautils/lib)

include_directories(AFTER
		${ZK_INCLUDE_DIRS}
		${SQLITE3_INCLUDE_DIRS})

link_directories(
		${ZK_LIBRARY_DIRS}
		${SQLITE3_LIBRARY_DIRS})


add_library(sqliteutils SHARED rc.c sqlite_utils.c)

set_target_properties(sqliteutils PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(sqliteutils metautils
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

add_library(sqlitereporemote SHARED
		sqlx_remote.c
		sqlx_remote_ex.c
		replication_client.c)

set_target_properties(sqlitereporemote PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(sqlitereporemote metautils
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

add_library(sqliterepo SHARED
		gridd_client_pool.c
		synchro.c
		version.c
		cache.c
		hash.c
		replication.c
		election.c
		replication_dispatcher.c
		repository.c
		restoration.c
		zk_manager.c
		upgrade.c)

set_target_properties(sqliterepo PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(sqliterepo metautils
		sqlitereporemote sqliteutils
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES} ${ZK_LIBRARIES})

install(TARGETS sqliterepo sqliteutils sqlitereporemote
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== rawx-lib/src/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.rawx.tools")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ../..)

include_directories(AFTER
		${LZO_INCLUDE_DIRS}
		${ZLIB_INCLUDE_DIRS}
		${ATTR_INCLUDE_DIRS})

link_directories(
		${LZO_LIBRARY_DIRS}
		${ZLIB_LIBRARY_DIRS}
		${ATTR_LIBRARY_DIRS})

add_library(rawx SHARED
		attr_handler.c
		compression.c
		lzo_compress.c
		zlib_compress.c)

set_target_properties(rawx PROPERTIES SOVERSION ${ABI_VERSION})

target_link_libraries(rawx
		metautils gridcluster
		${ATTR_LIBRARIES} ${ZLIB_LIBRARIES} ${LZO_LIBRARIES})

install(TARGETS rawx
		LIBRARY DESTINATION ${LD_LIBDIR})

=== tests/func/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.tests.func")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ../..)

include_directories(AFTER
		${GLIB2_INCLUDE_DIRS}
		${CURL_INCLUDE_DIRS}
		${JSONC_INCLUDE_DIRS})

link_directories(
		${GLIB2_LIBRARY_DIRS}
		${CURL_LIBRARY_DIRS}
		${JSONC_LIBRARY_DIRS})

if (DEFINED ALLOW_HIREDIS)
	if (HIREDIS_FOUND)
		add_executable(test_cache_redis test_cache_redis.c)
		target_link_libraries(test_cache_redis oiocache oiocache_redis)
		add_test(NAME cache/redis COMMAND test_cache_redis)
	endif ()
endif ()

if (DEFINED ALLOW_LIBMEMCACHED)
	if (LIBMEMCACHED_FOUND)
		add_executable(test_cache_memcached test_cache_memcached.c)
		target_link_libraries(test_cache_memcached oiocache oiocache_memcached)
		add_test(NAME cache/memcached COMMAND test_cache_memcached)
	endif ()
endif ()

add_library(oiosds_test SHARED testlib_sds.c)
target_link_libraries(oiosds_test oiosds)
set_target_properties(oiosds_test PROPERTIES
		SOVERSION ${ABI_VERSION})
add_test(NAME core/sds
		COMMAND /usr/bin/env python ${CMAKE_CURRENT_SOURCE_DIR}/test_oiosds.py ${CMAKE_CURRENT_BINARY_DIR})

add_library(oiohttp_test SHARED testlib_http.c)
target_link_libraries(oiohttp_test oiosds)
set_target_properties(oiohttp_test PROPERTIES
		SOVERSION ${ABI_VERSION})
add_test(NAME core/http
		COMMAND /usr/bin/env python ${CMAKE_CURRENT_SOURCE_DIR}/test_oiohttp.py ${CMAKE_CURRENT_BINARY_DIR})

add_executable(test_oio_cs test_cs.c)
target_link_libraries(test_oio_cs oiosds)
add_test(NAME core/cs COMMAND test_oio_cs)

add_executable(test_oio_dir test_dir.c)
target_link_libraries(test_oio_dir oiosds)
add_test(NAME core/dir COMMAND test_oio_dir)

add_executable(test_sqlx_client_sds test_sqlx_client.c)
target_link_libraries(test_sqlx_client_sds oiosqlx oiosqlx_direct ${COMMON})
add_test(NAME sqlx/client/sds COMMAND test_sqlx_client_sds)

add_executable(test_weird_chars test_weird_chars.c)
target_link_libraries(test_weird_chars oiosds oiocore)
add_test(NAME core/sds/weird_chars COMMAND test_weird_chars)

=== tests/unit/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.tests.unit")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ../..
		${CMAKE_CURRENT_BINARY_DIR}/../..
		${CMAKE_CURRENT_BINARY_DIR}/../../metautils/lib
		${ZK_INCLUDE_DIRS}
		${SQLITE3_INCLUDE_DIRS})

link_directories(
		${ZK_LIBRARY_DIRS}
		${SQLITE3_LIBRARY_DIRS})

set(COMMON oiocore oiosds metautils ${GLIB2_LIBRARIES})

add_executable(test_lb test_lb.c)
target_link_libraries(test_lb metautils ${COMMON})
add_test(NAME core/lb COMMAND test_lb)

add_executable(test_oio_ext test_ext.c)
target_link_libraries(test_oio_ext ${COMMON})
add_test(NAME core/ext COMMAND test_oio_ext)

add_executable(test_oio_url test_url.c)
target_link_libraries(test_oio_url ${COMMON})
add_test(NAME core/url COMMAND test_oio_url)

add_executable(test_core_sysstat test_core_sysstat.c)
target_link_libraries(test_core_sysstat ${COMMON})
add_test(NAME core/sysstat COMMAND test_core_sysstat)

add_executable(test_cache_lru test_cache_lru.c)
target_link_libraries(test_cache_lru oiocache)
add_test(NAME cache/lru COMMAND test_cache_lru)

add_executable(test_stg_policy test_stg_policy.c)
target_link_libraries(test_stg_policy ${COMMON})
add_test(NAME metautils/stgpol COMMAND test_stg_policy)

add_executable(test_svc_policy test_svc_policy.c)
target_link_libraries(test_svc_policy ${COMMON})
add_test(NAME metautils/svc_policy COMMAND test_svc_policy)

add_executable(test_logger test_logger.c)
target_link_libraries(test_logger ${COMMON})
add_test(NAME metautils/logger COMMAND test_logger)

add_executable(test_addr test_addr.c)
target_link_libraries(test_addr ${COMMON})
add_test(NAME metautils/addr COMMAND test_addr)

add_executable(test_gridd_client test_gridd_client.c)
target_link_libraries(test_gridd_client ${COMMON})
add_test(NAME metautils/gridd_client COMMAND test_gridd_client)

add_executable(test_lrutree test_lrutree.c)
target_link_libraries(test_lrutree ${COMMON})
add_test(NAME metautils/lru COMMAND test_lrutree)

add_executable(test_str test_str.c)
target_link_libraries(test_str ${COMMON})
add_test(NAME metautils/str COMMAND test_str)

add_executable(test_gba test_gba.c)
target_link_libraries(test_gba ${COMMON})
add_test(NAME metautils/gba COMMAND test_gba)

add_executable(test_error test_error.c)
target_link_libraries(test_error ${COMMON})
add_test(NAME metautils/err COMMAND test_error)

add_executable(test_meta2_backend test_meta2_backend.c)
target_link_libraries(test_meta2_backend meta2v2 ${COMMON})
add_test(NAME meta2/backend COMMAND test_meta2_backend)

add_executable(test_stats_holder test_stats_holder.c)
target_link_libraries(test_stats_holder server ${COMMON})
add_test(NAME server/stats COMMAND test_stats_holder)

add_executable(test_sqliterepo_version test_sqliterepo_version.c)
target_link_libraries(test_sqliterepo_version sqliterepo ${COMMON})
add_test(NAME sqliterepo/version COMMAND test_sqliterepo_version)

add_executable(test_sqliterepo_election test_sqliterepo_election.c)
target_link_libraries(test_sqliterepo_election sqliterepo ${COMMON})
add_test(NAME sqliterepo/election COMMAND test_sqliterepo_election)

add_executable(test_sqliterepo_cache test_sqliterepo_cache.c)
target_link_libraries(test_sqliterepo_cache sqliterepo sqlitereporemote ${COMMON})
add_test(NAME sqliterepo/cache COMMAND test_sqliterepo_cache)

add_executable(test_sqliterepo_repo test_sqliterepo_repo.c)
target_link_libraries(test_sqliterepo_repo sqliterepo sqlitereporemote ${COMMON})
add_test(NAME sqliterepo/repository COMMAND test_sqliterepo_repo)

add_executable(test_sqlx_client_mem test_sqlx_client.c)
target_link_libraries(test_sqlx_client_mem oiosqlx oiosqlx_local ${COMMON})
add_test(NAME sqlx/client/mem COMMAND test_sqlx_client_mem)

add_executable(test_events_queue test_events_queue.c)
target_link_libraries(test_events_queue sqlxsrv oioevents ${COMMON})
add_test(NAME events/abstract COMMAND test_events_queue)

add_executable(test_events_beanstalkd test_events_beanstalkd.c)
target_link_libraries(test_events_beanstalkd ${COMMON} oioevents server)
add_test(NAME events/beanstalkd COMMAND test_events_beanstalkd)

=== debian/changelog ===
openio-sds (3.2.4-1) xenial; urgency=medium

  * New release

 -- Romain Acciari <romain.acciari@openio.io>  Fri, 16 Jun 2017 15:52:20 +0000

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
DH_VERBOSE = 1
export DH_OPTIONS=-v
export DEB_BUILD_OPTIONS += nocheck
export PBR_VERSION=3.2.4
DESTDIR=$(CURDIR)/debian/openio-sds
PYTHON_SITELIB=$(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


# main packaging script based on dh7 syntax
%:
	dh $@ --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem cmake -- \
	-DCMAKE_BUILD_TYPE="Release" \
	-DCMAKE_INSTALL_PREFIX="/usr" \
	-DLD_LIBDIR="lib" \
	-DEXE_PREFIX="oio" \
	-DZK_LIBDIR="/usr/lib" \
	-DZK_INCDIR="/usr/include/zookeeper" \
	-DLZO_INCDIR="/usr/include/lzo" \
	-DAPACHE2_LIBDIR="/usr/lib/apache2" \
	-DAPACHE2_INCDIR="/usr/include/apache2" \
	-DLIBRAIN_LIBDIR="/usr/lib" \
	-DLIBRAIN_INCDIR="/usr/include" \
	-DSOCKET_OPTIMIZED=1

override_dh_auto_build:
	dh_auto_build --buildsystem cmake
	python setup.py build

override_dh_install:
	dh_install
	python setup.py install -O1 --skip-build --prefix=/usr --install-layout=deb --root $(DESTDIR)
	# Install OpenIO SDS directories
	mkdir -pv $(DESTDIR)/var/log/oio/sds \
		$(DESTDIR)/var/lib/oio/sds \
		$(DESTDIR)/etc/oio/sds \
		$(DESTDIR)/run/oio/sds



# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
#override_dh_auto_configure:
#       dh_auto_configure -- \
#

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --dbg-package=openio-sds-dbg

override_dh_auto_install:
	dh_auto_install --destdir=debian/openio-sds

## openio-sds 4.1.5

=== debian/changelog ===
openio-sds (4.1.5-4) stretch; urgency=medium

  * Removed cliff-tablib runtime dependency

 -- Romain Acciari <romain.acciari@openio.io>  Mon, 27 Nov 2017 12:47:37 +0000

openio-sds (4.1.5-3) stretch; urgency=medium

  * Update libleveldb dependency

 -- Romain Acciari <romain.acciari@openio.io>  Thu, 02 Nov 2017 13:59:59 +0000

openio-sds (4.1.5-2) stretch; urgency=medium

  * Update libjson dependency

 -- Romain Acciari <romain.acciari@openio.io>  Thu, 02 Nov 2017 13:30:10 +0000

openio-sds (4.1.5-1) stretch; urgency=medium

  * Rebuilt for Debian Stretch

 -- Romain Acciari <romain.acciari@openio.io>  Mon, 30 Oct 2017 14:10:47 +0000

=== debian/control ===
Source: openio-sds
Section: unknown
Priority: optional
Maintainer: Romain Acciari <romain.acciari@openio.io>
Build-Depends:
 debhelper (>= 9)
 , cmake
 , libglib2.0-dev (>= 2.42)
 , libzookeeper-mt-dev (>= 3.4.5)
 , python-dev
 , python-setuptools
 , libzmq3-dev
 , libcurl4-gnutls-dev
 , libapreq2-dev (>= 1.2)
 , libsqlite3-dev (>= 3.7.11)
 , libattr1-dev (>= 2.4.32)
 , libevent-dev (>= 2.0)
 , apache2 (>= 2.2)
 , apache2-dev (>= 2.2)
 , liblzo2-dev (>= 2.0)
 , openio-gridinit
 , openio-asn1c (>= 0.9.27.1)
 , libdb-dev
 , libjson-c-dev (>= 0.12)
 , flex
 , bison
 , curl
 , python-pbr
 , libleveldb-dev
Standards-Version: 3.9.5
Homepage: <insert the upstream URL, if relevant>
#Vcs-Git: git://anonscm.debian.org/collab-maint/openio-sds.git
#Vcs-Browser: http://anonscm.debian.org/?p=collab-maint/openio-sds.git;a=summary

Package: openio-sds
Architecture: any
Depends:
 ${shlibs:Depends}
 , ${misc:Depends}
 , python-xattr (>= 0.8.0) | python-pyxattr (>= 0.4.0)
 , python-eventlet (>= 0.15.2)
 , gunicorn (>= 19.4.5)
 , python-requests (>= 2.6.0)
 , python-flask
 , python-redis
 , apache2
 , libexpat1
 , openio-asn1c (>= 0.9.27.1)
 , libglib2.0-0 (>= 2.42)
 , zlib1g
 , libjson-c3 (>= 0.12)
 , python-zookeeper (>= 3.4.5)
 , libapr1 (>= 1.2)
 , libevent-2.0-5
 , liblzo2-2 (>= 2.0)
 , openio-gridinit
 , libdb5.3
 , python-pbr
 , python-yaml
 , python-plyvel
 , libsqlite3-0 (>= 3.7.11)
 , libleveldb1v5
 , python-simplejson (>= 2.0.9)
 , python-flask
 , python-eventlet
 , python-redis
 , python-tablib
 , python-cliff (>= 1.13)
 , python-pyeclib (>= 1.2.0)
 , python-concurrent.futures
Description: OpenIO Cloud Storage Solution
 OpenIO software storage solution is designed to handle PETA-bytes of
 data in a distributed way, data such as: images, videos, documents, emails,
 and any other personal unstructured data.
 OpenIO is a fork of Redcurrant, from Worldline by Atos.

Package: openio-sds-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
    openio-sds (= ${binary:Version}),
    ${misc:Depends}
Description: debugging symbols for openio-sds
 OpenIO software storage solution is designed to handle PETA-bytes of
 data in a distributed way, data such as: images, videos, documents, emails,
 and any other personal unstructured data.
 OpenIO is a fork of Redcurrant, from Worldline by Atos.
 .
 This package contains the debugging symbols for openio-sds.

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 DH_VERBOSE = 1
 export DH_OPTIONS=-v
 export DEB_BUILD_OPTIONS += nocheck
-export PBR_VERSION=3.2.4
+export PBR_VERSION=3.3.1
 DESTDIR=$(CURDIR)/debian/openio-sds
 PYTHON_SITELIB=$(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")
